{************************************************************
 * Demontriert die Verwendung der Komponente TNewEditWindow *
 * -------------------------------------------------------- *
 * Copyright 1997, Soft-Solutions T.Greiling                *
 * Sie knnen diese Unit an Ihre eigenen Bedrfnisse        *
 * anpassen und alle verwendeten Techniken in Ihren         *
 * Projekten einsetzen.                                     *
 ************************************************************}
unit DemoForm;
{$I CPDIR.INC}

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
	Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls, ExtEdit,
	Messages;

type
   TMain = class(TForm)
      MainMenu: TMainMenu;
      FileMenu: TMenuItem;
      OpenItem: TMenuItem;
      SaveItem: TMenuItem;
      ExitItem: TMenuItem;
      N1: TMenuItem;
      OpenDialog: TOpenDialog;
      SaveDialog: TSaveDialog;
      Help1: TMenuItem;
      About1: TMenuItem;
      SpeedPanel: TPanel;
      OpenBtn: TSpeedButton;
      SaveBtn: TSpeedButton;
      ExitBtn: TSpeedButton;
      StatusBar: TStatusBar;
      NewEditWindow1: TNewEditWindow;
      Panel1: TPanel;
      Button1: TButton;
      CheckBox1: TCheckBox;
      Button2: TButton;
		ProgressBar1: TProgressBar;
      Label1: TLabel;
      Edit1: TEdit;
      Label2: TLabel;
      Edit2: TEdit;
      procedure ShowHint(Sender: TObject);
      procedure ExitItemClick(Sender: TObject);
      procedure OpenItemClick(Sender: TObject);
      procedure SaveItemClick(Sender: TObject);
      procedure About1Click(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure NewEditWindow1NewPos(Sender: TObject);
      procedure NewEditWindow1EditModeChange(Sender: TObject);
      procedure NewEditWindow1Change(Sender: TObject);
      procedure CheckBox1Click(Sender: TObject);
      procedure Button2Click(Sender: TObject);
      procedure Button1Click(Sender: TObject);
		procedure NewEditWindow1Resize(Sender: TObject);
      procedure NewEditWindow1DragOver(Sender, Source: TObject;
				      X,Y: Integer; State: TDragState; var Accept: Boolean);
      procedure NewEditWindow1DragDrop(Sender, Source: TObject;
				      X,Y: Integer);
      procedure FormActivate(Sender: TObject);
	private
	   { Private declarations }
   public
   	{ Public declarations }
   end;

var
	Main: TMain;

implementation

uses About, SysUtils;

{$R *.DFM}

procedure TMain.FormCreate(Sender: TObject);
var
	i: Integer;
begin
	Application.OnHint:=ShowHint;
   StatusBar.Panels[0].Text:='1:1';
   // nur zur Demonstration
   i:=3;
   SendMessage(NewEditWindow1.Handle,EM_SETTABSTOPS,1,LongInt(@i));
end;

procedure TMain.FormActivate(Sender: TObject);
begin
	NewEditWindow1.SetFocus;
end;

procedure TMain.ShowHint(Sender: TObject);
begin
	StatusBar.Panels[3].Text := Application.Hint;
end;

procedure TMain.ExitItemClick(Sender: TObject);
begin
	Close;
end;

procedure TMain.OpenItemClick(Sender: TObject);
begin
	if OpenDialog.Execute then
   begin
  		NewEditWindow1.LoadFromFile(OpenDialog.Filename);
      StatusBar.Panels[1].Text:='Einfgen';
		StatusBar.Panels[2].Text:='';
		Edit2.Text:=IntToStr(NewEditWindow1.PageCount);
   end;
end;

procedure TMain.SaveItemClick(Sender: TObject);
begin
	if SaveDialog.Execute then
   	NewEditWindow1.SaveToFile(SaveDialog.Filename);
	if NewEditWindow1.Modified then
		StatusBar.Panels[2].Text:='Gendert'
   else
		StatusBar.Panels[2].Text:='';
   Button2.Enabled:=Boolean(SendMessage(NewEditWindow1.Handle,EM_CANUNDO,0,0));
end;

procedure TMain.About1Click(Sender: TObject);
begin
	AboutBox.ShowModal;
end;

procedure TMain.NewEditWindow1NewPos(Sender: TObject);
begin
	// Position ausgeben
	StatusBar.Panels[0].Text:=IntToStr(NewEditWindow1.CaretLine+1)+
   									':'+
                              IntToStr(NewEditWindow1.CaretPos+1);
	// Zeilenlnge aktualisieren
   Edit1.Text:=IntToStr(NewEditWindow1.LineLen);
end;

procedure TMain.NewEditWindow1EditModeChange(Sender: TObject);
begin
	// Editiermodus gendert
	if NewEditWindow1.InsertMode then
		StatusBar.Panels[1].Text:='Einfgen'
   else
		StatusBar.Panels[1].Text:='berschreiben';
end;

procedure TMain.NewEditWindow1Change(Sender: TObject);
begin
	if NewEditWindow1.Modified then
		StatusBar.Panels[2].Text:='Gendert'
   else
		StatusBar.Panels[2].Text:='';
   Button2.Enabled:=Boolean(SendMessage(NewEditWindow1.Handle,EM_CANUNDO,0,0));
	// Zeilenlnge aktualisieren
   Edit1.Text:=IntToStr(NewEditWindow1.LineLen);
   // Seitenanzahl aktualisieren
	Edit2.Text:=IntToStr(NewEditWindow1.PageCount);
end;

procedure TMain.CheckBox1Click(Sender: TObject);
begin
	// Ausfhrungsposition simulieren
	if not CheckBox1.Checked then
   	NewEditWindow1.CurLine:=-1
   else
   	if NewEditWindow1.LineCount>0 then
	   	NewEditWindow1.CurLine:=0;
	Button1.Enabled:=CheckBox1.Checked and (NewEditWindow1.LineCount>0);
end;

procedure TMain.Button2Click(Sender: TObject);
begin
	// UNDO-Funktion
  	NewEditWindow1.SetFocus;
	if Boolean(SendMessage(NewEditWindow1.Handle,EM_CANUNDO,0,0)) then
   	SendMessage(NewEditWindow1.Handle,EM_UNDO,0,0);
end;

procedure TMain.Button1Click(Sender: TObject);
begin
	// Ausfhrungsposition simulieren
	if NewEditWindow1.LineCount-1>NewEditWindow1.CurLine then
   	NewEditWindow1.CurLine:=NewEditWindow1.CurLine+1
   else
   	NewEditWindow1.CurLine:=0;
   NewEditWindow1.SelStart:=SendMessage(NewEditWindow1.Handle,EM_LINEINDEX,
   	NewEditWindow1.CurLine,0);
   SendMessage(NewEditWindow1.Handle,EM_SCROLLCARET,0,0);
end;

procedure TMain.NewEditWindow1Resize(Sender: TObject);
begin
	// Seitenanzahl aktualisieren
	Edit2.Text:=IntToStr(NewEditWindow1.PageCount);
end;

// Drag&Drop Demonstration
procedure TMain.NewEditWindow1DragOver(Sender, Source: TObject; X,
	Y: Integer; State: TDragState; var Accept: Boolean);
begin
	Accept:=Source is TNewEditWindow;
end;

procedure TMain.NewEditWindow1DragDrop(Sender, Source: TObject; X,
	Y: Integer);
var
	s: String;
   l,off: LongInt;
begin
	if (Source is TNewEditWindow) then
   begin
   	s:=(Source as TNewEditWindow).SelText;
      if (Sender as TNewEditWindow).GetIndexFromPos(x,y,l,off) then
      begin
      	(Sender as TNewEditWindow).SelStart:=
         	SendMessage((Sender as TNewEditWindow).Handle,EM_LineIndex,l,0)+
            off;
	      SendMessage((Sender as TNewEditWindow).Handle,EM_REPLACESEL,Word(True),LongInt(PChar(s)));
      end;
   end;
   NewEditWindow1.SetFocus;
end;

end.

